/*
cgo stubs for package tokenizer.
File is generated by gopy. Do not edit.
gopy build -output=tokenizer -vm=/opt/python/cp37-cp37m/bin/python github.com/cohere-ai/tokenizer
*/

package main

/*

#cgo CFLAGS: -I/opt/python/cp37-cp37m/include/python3.7m -Wno-error -Wno-implicit-function-declaration -Wno-int-conversion
#cgo LDFLAGS: -L/opt/_internal/cpython-3.7.13/lib -lpython3.7m -lcrypt -lpthread -ldl  -lutil -lm

// #define Py_LIMITED_API // need full API for PyRun*
#include <Python.h>
typedef uint8_t bool;
// static inline is trick for avoiding need for extra .c file
// the following are used for build value -- switch on reflect.Kind
// or the types equivalent
static inline PyObject* gopy_build_bool(uint8_t val) {
	return Py_BuildValue("b", val);
}
static inline PyObject* gopy_build_int64(int64_t val) {
	return Py_BuildValue("k", val);
}
static inline PyObject* gopy_build_uint64(uint64_t val) {
	return Py_BuildValue("K", val);
}
static inline PyObject* gopy_build_float64(double val) {
	return Py_BuildValue("d", val);
}
static inline PyObject* gopy_build_string(const char* val) {
	return Py_BuildValue("s", val);
}
static inline void gopy_decref(PyObject* obj) { // macro
	Py_XDECREF(obj);
}
static inline void gopy_incref(PyObject* obj) { // macro
	Py_XINCREF(obj);
}
static inline int gopy_method_check(PyObject* obj) { // macro
	return PyMethod_Check(obj);
}
static inline void gopy_err_handle() {
	if(PyErr_Occurred() != NULL) {
		PyErr_Print();
	}
}

*/
import "C"
import (
	"reflect"
	"unsafe"

	"github.com/go-python/gopy/gopyh" // handler

	"io"

	"github.com/cohere-ai/tokenizer"
)

// main doesn't do anything in lib / pkg mode, but is essential for exe mode
func main() {

}

// initialization functions -- can be called from python after library is loaded
// GoPyInitRunFile runs a separate python file -- call in GoPyInit if it
// steals the main thread e.g., for GUI event loop, as in GoGi startup.

//export GoPyInit
func GoPyInit() {

}

// type for the handle -- int64 for speed (can switch to string)
type GoHandle int64
type CGoHandle C.longlong

// DecRef decrements the reference count for the specified handle
// and deletes it it goes to zero.
//export DecRef
func DecRef(handle CGoHandle) {
	gopyh.DecRef(gopyh.CGoHandle(handle))
}

// IncRef increments the reference count for the specified handle.
//export IncRef
func IncRef(handle CGoHandle) {
	gopyh.IncRef(gopyh.CGoHandle(handle))
}

// NumHandles returns the number of handles currently in use.
//export NumHandles
func NumHandles() int {
	return gopyh.NumHandles()
}

// boolGoToPy converts a Go bool to python-compatible C.char
func boolGoToPy(b bool) C.char {
	if b {
		return 1
	}
	return 0
}

// boolPyToGo converts a python-compatible C.Char to Go bool
func boolPyToGo(b C.char) bool {
	if b != 0 {
		return true
	}
	return false
}

func complex64GoToPy(c complex64) *C.PyObject {
	return C.PyComplex_FromDoubles(C.double(real(c)), C.double(imag(c)))
}

func complex64PyToGo(o *C.PyObject) complex64 {
	v := C.PyComplex_AsCComplex(o)
	return complex(float32(v.real), float32(v.imag))
}

func complex128GoToPy(c complex128) *C.PyObject {
	return C.PyComplex_FromDoubles(C.double(real(c)), C.double(imag(c)))
}

func complex128PyToGo(o *C.PyObject) complex128 {
	v := C.PyComplex_AsCComplex(o)
	return complex(float64(v.real), float64(v.imag))
}

// --- generated code for package: tokenizer below: ---

// ---- External Types Outside of Targeted Packages ---

// Converters for pointer handles for type: io.Reader
func ptrFromHandle_io_Reader(h CGoHandle) io.Reader {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "io.Reader")
	if p == nil {
		return nil
	}
	return p.(io.Reader)
}
func handleFromPtr_io_Reader(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("io.Reader", p))
}

// ---- Package: go ---

// ---- Types ---

// Converters for implicit pointer handles for type: []bool
func ptrFromHandle_Slice_bool(h CGoHandle) *[]bool {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]bool")
	if p == nil {
		return nil
	}
	return p.(*[]bool)
}
func deptrFromHandle_Slice_bool(h CGoHandle) []bool {
	p := ptrFromHandle_Slice_bool(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_bool(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]bool", p))
}

// --- wrapping slice: []bool ---
//export Slice_bool_CTor
func Slice_bool_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_bool(&[]bool{}))
}

//export Slice_bool_len
func Slice_bool_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_bool(handle))
}

//export Slice_bool_elem
func Slice_bool_elem(handle CGoHandle, _idx int) C.char {
	s := deptrFromHandle_Slice_bool(handle)
	return boolGoToPy(s[_idx])
}

//export Slice_bool_subslice
func Slice_bool_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_bool(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_bool(&ss))
}

//export Slice_bool_set
func Slice_bool_set(handle CGoHandle, _idx int, _vl C.char) {
	s := deptrFromHandle_Slice_bool(handle)
	s[_idx] = boolPyToGo(_vl)
}

//export Slice_bool_append
func Slice_bool_append(handle CGoHandle, _vl C.char) {
	s := ptrFromHandle_Slice_bool(handle)
	*s = append(*s, boolPyToGo(_vl))
}

// Converters for implicit pointer handles for type: []byte
func ptrFromHandle_Slice_byte(h CGoHandle) *[]byte {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]byte")
	if p == nil {
		return nil
	}
	return p.(*[]byte)
}
func deptrFromHandle_Slice_byte(h CGoHandle) []byte {
	p := ptrFromHandle_Slice_byte(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_byte(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]byte", p))
}

// --- wrapping slice: []byte ---
//export Slice_byte_CTor
func Slice_byte_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_byte(&[]byte{}))
}

//export Slice_byte_len
func Slice_byte_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_byte(handle))
}

//export Slice_byte_elem
func Slice_byte_elem(handle CGoHandle, _idx int) C.char {
	s := deptrFromHandle_Slice_byte(handle)
	return C.char(s[_idx])
}

//export Slice_byte_subslice
func Slice_byte_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_byte(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_byte(&ss))
}

//export Slice_byte_set
func Slice_byte_set(handle CGoHandle, _idx int, _vl C.char) {
	s := deptrFromHandle_Slice_byte(handle)
	s[_idx] = byte(_vl)
}

//export Slice_byte_append
func Slice_byte_append(handle CGoHandle, _vl C.char) {
	s := ptrFromHandle_Slice_byte(handle)
	*s = append(*s, byte(_vl))
}

// Converters for implicit pointer handles for type: []float32
func ptrFromHandle_Slice_float32(h CGoHandle) *[]float32 {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]float32")
	if p == nil {
		return nil
	}
	return p.(*[]float32)
}
func deptrFromHandle_Slice_float32(h CGoHandle) []float32 {
	p := ptrFromHandle_Slice_float32(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_float32(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]float32", p))
}

// --- wrapping slice: []float32 ---
//export Slice_float32_CTor
func Slice_float32_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_float32(&[]float32{}))
}

//export Slice_float32_len
func Slice_float32_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_float32(handle))
}

//export Slice_float32_elem
func Slice_float32_elem(handle CGoHandle, _idx int) C.float {
	s := deptrFromHandle_Slice_float32(handle)
	return C.float(s[_idx])
}

//export Slice_float32_subslice
func Slice_float32_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_float32(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_float32(&ss))
}

//export Slice_float32_set
func Slice_float32_set(handle CGoHandle, _idx int, _vl C.float) {
	s := deptrFromHandle_Slice_float32(handle)
	s[_idx] = float32(_vl)
}

//export Slice_float32_append
func Slice_float32_append(handle CGoHandle, _vl C.float) {
	s := ptrFromHandle_Slice_float32(handle)
	*s = append(*s, float32(_vl))
}

// Converters for implicit pointer handles for type: []float64
func ptrFromHandle_Slice_float64(h CGoHandle) *[]float64 {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]float64")
	if p == nil {
		return nil
	}
	return p.(*[]float64)
}
func deptrFromHandle_Slice_float64(h CGoHandle) []float64 {
	p := ptrFromHandle_Slice_float64(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_float64(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]float64", p))
}

// --- wrapping slice: []float64 ---
//export Slice_float64_CTor
func Slice_float64_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_float64(&[]float64{}))
}

//export Slice_float64_len
func Slice_float64_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_float64(handle))
}

//export Slice_float64_elem
func Slice_float64_elem(handle CGoHandle, _idx int) C.double {
	s := deptrFromHandle_Slice_float64(handle)
	return C.double(s[_idx])
}

//export Slice_float64_subslice
func Slice_float64_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_float64(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_float64(&ss))
}

//export Slice_float64_set
func Slice_float64_set(handle CGoHandle, _idx int, _vl C.double) {
	s := deptrFromHandle_Slice_float64(handle)
	s[_idx] = float64(_vl)
}

//export Slice_float64_append
func Slice_float64_append(handle CGoHandle, _vl C.double) {
	s := ptrFromHandle_Slice_float64(handle)
	*s = append(*s, float64(_vl))
}

// Converters for implicit pointer handles for type: []int
func ptrFromHandle_Slice_int(h CGoHandle) *[]int {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]int")
	if p == nil {
		return nil
	}
	return p.(*[]int)
}
func deptrFromHandle_Slice_int(h CGoHandle) []int {
	p := ptrFromHandle_Slice_int(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_int(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]int", p))
}

// --- wrapping slice: []int ---
//export Slice_int_CTor
func Slice_int_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_int(&[]int{}))
}

//export Slice_int_len
func Slice_int_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_int(handle))
}

//export Slice_int_elem
func Slice_int_elem(handle CGoHandle, _idx int) C.longlong {
	s := deptrFromHandle_Slice_int(handle)
	return C.longlong(s[_idx])
}

//export Slice_int_subslice
func Slice_int_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_int(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_int(&ss))
}

//export Slice_int_set
func Slice_int_set(handle CGoHandle, _idx int, _vl C.longlong) {
	s := deptrFromHandle_Slice_int(handle)
	s[_idx] = int(_vl)
}

//export Slice_int_append
func Slice_int_append(handle CGoHandle, _vl C.longlong) {
	s := ptrFromHandle_Slice_int(handle)
	*s = append(*s, int(_vl))
}

// Converters for implicit pointer handles for type: []int16
func ptrFromHandle_Slice_int16(h CGoHandle) *[]int16 {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]int16")
	if p == nil {
		return nil
	}
	return p.(*[]int16)
}
func deptrFromHandle_Slice_int16(h CGoHandle) []int16 {
	p := ptrFromHandle_Slice_int16(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_int16(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]int16", p))
}

// --- wrapping slice: []int16 ---
//export Slice_int16_CTor
func Slice_int16_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_int16(&[]int16{}))
}

//export Slice_int16_len
func Slice_int16_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_int16(handle))
}

//export Slice_int16_elem
func Slice_int16_elem(handle CGoHandle, _idx int) C.short {
	s := deptrFromHandle_Slice_int16(handle)
	return C.short(s[_idx])
}

//export Slice_int16_subslice
func Slice_int16_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_int16(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_int16(&ss))
}

//export Slice_int16_set
func Slice_int16_set(handle CGoHandle, _idx int, _vl C.short) {
	s := deptrFromHandle_Slice_int16(handle)
	s[_idx] = int16(_vl)
}

//export Slice_int16_append
func Slice_int16_append(handle CGoHandle, _vl C.short) {
	s := ptrFromHandle_Slice_int16(handle)
	*s = append(*s, int16(_vl))
}

// Converters for implicit pointer handles for type: []int32
func ptrFromHandle_Slice_int32(h CGoHandle) *[]int32 {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]int32")
	if p == nil {
		return nil
	}
	return p.(*[]int32)
}
func deptrFromHandle_Slice_int32(h CGoHandle) []int32 {
	p := ptrFromHandle_Slice_int32(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_int32(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]int32", p))
}

// --- wrapping slice: []int32 ---
//export Slice_int32_CTor
func Slice_int32_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_int32(&[]int32{}))
}

//export Slice_int32_len
func Slice_int32_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_int32(handle))
}

//export Slice_int32_elem
func Slice_int32_elem(handle CGoHandle, _idx int) C.long {
	s := deptrFromHandle_Slice_int32(handle)
	return C.long(s[_idx])
}

//export Slice_int32_subslice
func Slice_int32_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_int32(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_int32(&ss))
}

//export Slice_int32_set
func Slice_int32_set(handle CGoHandle, _idx int, _vl C.long) {
	s := deptrFromHandle_Slice_int32(handle)
	s[_idx] = int32(_vl)
}

//export Slice_int32_append
func Slice_int32_append(handle CGoHandle, _vl C.long) {
	s := ptrFromHandle_Slice_int32(handle)
	*s = append(*s, int32(_vl))
}

// Converters for implicit pointer handles for type: []int64
func ptrFromHandle_Slice_int64(h CGoHandle) *[]int64 {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]int64")
	if p == nil {
		return nil
	}
	return p.(*[]int64)
}
func deptrFromHandle_Slice_int64(h CGoHandle) []int64 {
	p := ptrFromHandle_Slice_int64(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_int64(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]int64", p))
}

// --- wrapping slice: []int64 ---
//export Slice_int64_CTor
func Slice_int64_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_int64(&[]int64{}))
}

//export Slice_int64_len
func Slice_int64_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_int64(handle))
}

//export Slice_int64_elem
func Slice_int64_elem(handle CGoHandle, _idx int) C.longlong {
	s := deptrFromHandle_Slice_int64(handle)
	return C.longlong(s[_idx])
}

//export Slice_int64_subslice
func Slice_int64_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_int64(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_int64(&ss))
}

//export Slice_int64_set
func Slice_int64_set(handle CGoHandle, _idx int, _vl C.longlong) {
	s := deptrFromHandle_Slice_int64(handle)
	s[_idx] = int64(_vl)
}

//export Slice_int64_append
func Slice_int64_append(handle CGoHandle, _vl C.longlong) {
	s := ptrFromHandle_Slice_int64(handle)
	*s = append(*s, int64(_vl))
}

// Converters for implicit pointer handles for type: []int8
func ptrFromHandle_Slice_int8(h CGoHandle) *[]int8 {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]int8")
	if p == nil {
		return nil
	}
	return p.(*[]int8)
}
func deptrFromHandle_Slice_int8(h CGoHandle) []int8 {
	p := ptrFromHandle_Slice_int8(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_int8(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]int8", p))
}

// --- wrapping slice: []int8 ---
//export Slice_int8_CTor
func Slice_int8_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_int8(&[]int8{}))
}

//export Slice_int8_len
func Slice_int8_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_int8(handle))
}

//export Slice_int8_elem
func Slice_int8_elem(handle CGoHandle, _idx int) C.char {
	s := deptrFromHandle_Slice_int8(handle)
	return C.char(s[_idx])
}

//export Slice_int8_subslice
func Slice_int8_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_int8(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_int8(&ss))
}

//export Slice_int8_set
func Slice_int8_set(handle CGoHandle, _idx int, _vl C.char) {
	s := deptrFromHandle_Slice_int8(handle)
	s[_idx] = int8(_vl)
}

//export Slice_int8_append
func Slice_int8_append(handle CGoHandle, _vl C.char) {
	s := ptrFromHandle_Slice_int8(handle)
	*s = append(*s, int8(_vl))
}

// Converters for implicit pointer handles for type: []rune
func ptrFromHandle_Slice_rune(h CGoHandle) *[]rune {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]rune")
	if p == nil {
		return nil
	}
	return p.(*[]rune)
}
func deptrFromHandle_Slice_rune(h CGoHandle) []rune {
	p := ptrFromHandle_Slice_rune(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_rune(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]rune", p))
}

// --- wrapping slice: []rune ---
//export Slice_rune_CTor
func Slice_rune_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_rune(&[]rune{}))
}

//export Slice_rune_len
func Slice_rune_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_rune(handle))
}

//export Slice_rune_elem
func Slice_rune_elem(handle CGoHandle, _idx int) C.long {
	s := deptrFromHandle_Slice_rune(handle)
	return C.long(s[_idx])
}

//export Slice_rune_subslice
func Slice_rune_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_rune(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_rune(&ss))
}

//export Slice_rune_set
func Slice_rune_set(handle CGoHandle, _idx int, _vl C.long) {
	s := deptrFromHandle_Slice_rune(handle)
	s[_idx] = rune(_vl)
}

//export Slice_rune_append
func Slice_rune_append(handle CGoHandle, _vl C.long) {
	s := ptrFromHandle_Slice_rune(handle)
	*s = append(*s, rune(_vl))
}

// Converters for implicit pointer handles for type: []string
func ptrFromHandle_Slice_string(h CGoHandle) *[]string {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]string")
	if p == nil {
		return nil
	}
	return p.(*[]string)
}
func deptrFromHandle_Slice_string(h CGoHandle) []string {
	p := ptrFromHandle_Slice_string(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_string(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]string", p))
}

// --- wrapping slice: []string ---
//export Slice_string_CTor
func Slice_string_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_string(&[]string{}))
}

//export Slice_string_len
func Slice_string_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_string(handle))
}

//export Slice_string_elem
func Slice_string_elem(handle CGoHandle, _idx int) *C.char {
	s := deptrFromHandle_Slice_string(handle)
	return C.CString(s[_idx])
}

//export Slice_string_subslice
func Slice_string_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_string(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_string(&ss))
}

//export Slice_string_set
func Slice_string_set(handle CGoHandle, _idx int, _vl *C.char) {
	s := deptrFromHandle_Slice_string(handle)
	s[_idx] = C.GoString(_vl)
}

//export Slice_string_append
func Slice_string_append(handle CGoHandle, _vl *C.char) {
	s := ptrFromHandle_Slice_string(handle)
	*s = append(*s, C.GoString(_vl))
}

// Converters for implicit pointer handles for type: []uint
func ptrFromHandle_Slice_uint(h CGoHandle) *[]uint {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]uint")
	if p == nil {
		return nil
	}
	return p.(*[]uint)
}
func deptrFromHandle_Slice_uint(h CGoHandle) []uint {
	p := ptrFromHandle_Slice_uint(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_uint(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]uint", p))
}

// --- wrapping slice: []uint ---
//export Slice_uint_CTor
func Slice_uint_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_uint(&[]uint{}))
}

//export Slice_uint_len
func Slice_uint_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_uint(handle))
}

//export Slice_uint_elem
func Slice_uint_elem(handle CGoHandle, _idx int) C.ulonglong {
	s := deptrFromHandle_Slice_uint(handle)
	return C.ulonglong(s[_idx])
}

//export Slice_uint_subslice
func Slice_uint_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_uint(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_uint(&ss))
}

//export Slice_uint_set
func Slice_uint_set(handle CGoHandle, _idx int, _vl C.ulonglong) {
	s := deptrFromHandle_Slice_uint(handle)
	s[_idx] = uint(_vl)
}

//export Slice_uint_append
func Slice_uint_append(handle CGoHandle, _vl C.ulonglong) {
	s := ptrFromHandle_Slice_uint(handle)
	*s = append(*s, uint(_vl))
}

// Converters for implicit pointer handles for type: []uint16
func ptrFromHandle_Slice_uint16(h CGoHandle) *[]uint16 {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]uint16")
	if p == nil {
		return nil
	}
	return p.(*[]uint16)
}
func deptrFromHandle_Slice_uint16(h CGoHandle) []uint16 {
	p := ptrFromHandle_Slice_uint16(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_uint16(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]uint16", p))
}

// --- wrapping slice: []uint16 ---
//export Slice_uint16_CTor
func Slice_uint16_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_uint16(&[]uint16{}))
}

//export Slice_uint16_len
func Slice_uint16_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_uint16(handle))
}

//export Slice_uint16_elem
func Slice_uint16_elem(handle CGoHandle, _idx int) C.ushort {
	s := deptrFromHandle_Slice_uint16(handle)
	return C.ushort(s[_idx])
}

//export Slice_uint16_subslice
func Slice_uint16_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_uint16(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_uint16(&ss))
}

//export Slice_uint16_set
func Slice_uint16_set(handle CGoHandle, _idx int, _vl C.ushort) {
	s := deptrFromHandle_Slice_uint16(handle)
	s[_idx] = uint16(_vl)
}

//export Slice_uint16_append
func Slice_uint16_append(handle CGoHandle, _vl C.ushort) {
	s := ptrFromHandle_Slice_uint16(handle)
	*s = append(*s, uint16(_vl))
}

// Converters for implicit pointer handles for type: []uint32
func ptrFromHandle_Slice_uint32(h CGoHandle) *[]uint32 {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]uint32")
	if p == nil {
		return nil
	}
	return p.(*[]uint32)
}
func deptrFromHandle_Slice_uint32(h CGoHandle) []uint32 {
	p := ptrFromHandle_Slice_uint32(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_uint32(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]uint32", p))
}

// --- wrapping slice: []uint32 ---
//export Slice_uint32_CTor
func Slice_uint32_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_uint32(&[]uint32{}))
}

//export Slice_uint32_len
func Slice_uint32_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_uint32(handle))
}

//export Slice_uint32_elem
func Slice_uint32_elem(handle CGoHandle, _idx int) C.ulong {
	s := deptrFromHandle_Slice_uint32(handle)
	return C.ulong(s[_idx])
}

//export Slice_uint32_subslice
func Slice_uint32_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_uint32(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_uint32(&ss))
}

//export Slice_uint32_set
func Slice_uint32_set(handle CGoHandle, _idx int, _vl C.ulong) {
	s := deptrFromHandle_Slice_uint32(handle)
	s[_idx] = uint32(_vl)
}

//export Slice_uint32_append
func Slice_uint32_append(handle CGoHandle, _vl C.ulong) {
	s := ptrFromHandle_Slice_uint32(handle)
	*s = append(*s, uint32(_vl))
}

// Converters for implicit pointer handles for type: []uint64
func ptrFromHandle_Slice_uint64(h CGoHandle) *[]uint64 {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]uint64")
	if p == nil {
		return nil
	}
	return p.(*[]uint64)
}
func deptrFromHandle_Slice_uint64(h CGoHandle) []uint64 {
	p := ptrFromHandle_Slice_uint64(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_uint64(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]uint64", p))
}

// --- wrapping slice: []uint64 ---
//export Slice_uint64_CTor
func Slice_uint64_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_uint64(&[]uint64{}))
}

//export Slice_uint64_len
func Slice_uint64_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_uint64(handle))
}

//export Slice_uint64_elem
func Slice_uint64_elem(handle CGoHandle, _idx int) C.ulonglong {
	s := deptrFromHandle_Slice_uint64(handle)
	return C.ulonglong(s[_idx])
}

//export Slice_uint64_subslice
func Slice_uint64_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_uint64(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_uint64(&ss))
}

//export Slice_uint64_set
func Slice_uint64_set(handle CGoHandle, _idx int, _vl C.ulonglong) {
	s := deptrFromHandle_Slice_uint64(handle)
	s[_idx] = uint64(_vl)
}

//export Slice_uint64_append
func Slice_uint64_append(handle CGoHandle, _vl C.ulonglong) {
	s := ptrFromHandle_Slice_uint64(handle)
	*s = append(*s, uint64(_vl))
}

// Converters for implicit pointer handles for type: []uint8
func ptrFromHandle_Slice_uint8(h CGoHandle) *[]uint8 {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[]uint8")
	if p == nil {
		return nil
	}
	return p.(*[]uint8)
}
func deptrFromHandle_Slice_uint8(h CGoHandle) []uint8 {
	p := ptrFromHandle_Slice_uint8(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice_uint8(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[]uint8", p))
}

// --- wrapping slice: []uint8 ---
//export Slice_uint8_CTor
func Slice_uint8_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice_uint8(&[]uint8{}))
}

//export Slice_uint8_len
func Slice_uint8_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice_uint8(handle))
}

//export Slice_uint8_elem
func Slice_uint8_elem(handle CGoHandle, _idx int) C.uchar {
	s := deptrFromHandle_Slice_uint8(handle)
	return C.uchar(s[_idx])
}

//export Slice_uint8_subslice
func Slice_uint8_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice_uint8(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice_uint8(&ss))
}

//export Slice_uint8_set
func Slice_uint8_set(handle CGoHandle, _idx int, _vl C.uchar) {
	s := deptrFromHandle_Slice_uint8(handle)
	s[_idx] = uint8(_vl)
}

//export Slice_uint8_append
func Slice_uint8_append(handle CGoHandle, _vl C.uchar) {
	s := ptrFromHandle_Slice_uint8(handle)
	*s = append(*s, uint8(_vl))
}

// ---- Package: tokenizer ---

// ---- Types ---

// Converters for pointer handles for type: *tokenizer.Encoder
func ptrFromHandle_Ptr_tokenizer_Encoder(h CGoHandle) *tokenizer.Encoder {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "*tokenizer.Encoder")
	if p == nil {
		return nil
	}
	return gopyh.Embed(p, reflect.TypeOf(tokenizer.Encoder{})).(*tokenizer.Encoder)
}
func handleFromPtr_Ptr_tokenizer_Encoder(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("*tokenizer.Encoder", p))
}

// Converters for pointer handles for type: *tokenizer.Merge
func ptrFromHandle_Ptr_tokenizer_Merge(h CGoHandle) *tokenizer.Merge {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "*tokenizer.Merge")
	if p == nil {
		return nil
	}
	return gopyh.Embed(p, reflect.TypeOf(tokenizer.Merge{})).(*tokenizer.Merge)
}
func handleFromPtr_Ptr_tokenizer_Merge(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("*tokenizer.Merge", p))
}

// Converters for pointer handles for type: *tokenizer.WordCount
func ptrFromHandle_Ptr_tokenizer_WordCount(h CGoHandle) *tokenizer.WordCount {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "*tokenizer.WordCount")
	if p == nil {
		return nil
	}
	return gopyh.Embed(p, reflect.TypeOf(tokenizer.WordCount{})).(*tokenizer.WordCount)
}
func handleFromPtr_Ptr_tokenizer_WordCount(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("*tokenizer.WordCount", p))
}

// Converters for implicit pointer handles for type: [2]string
func ptrFromHandle_Array_2_string(h CGoHandle) *[2]string {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[2]string")
	if p == nil {
		return nil
	}
	return p.(*[2]string)
}
func deptrFromHandle_Array_2_string(h CGoHandle) [2]string {
	p := ptrFromHandle_Array_2_string(h)
	return *p
}
func handleFromPtr_Array_2_string(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[2]string", p))
}

// --- wrapping slice: [2]string ---
//export Array_2_string_CTor
func Array_2_string_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Array_2_string(&[2]string{}))
}

//export Array_2_string_len
func Array_2_string_len(handle CGoHandle) int {
	return len(deptrFromHandle_Array_2_string(handle))
}

//export Array_2_string_elem
func Array_2_string_elem(handle CGoHandle, _idx int) *C.char {
	s := deptrFromHandle_Array_2_string(handle)
	return C.CString(s[_idx])
}

//export Array_2_string_set
func Array_2_string_set(handle CGoHandle, _idx int, _vl *C.char) {
	s := deptrFromHandle_Array_2_string(handle)
	s[_idx] = C.GoString(_vl)
}

// Converters for implicit pointer handles for type: [][2]string
func ptrFromHandle_Slice__2_string(h CGoHandle) *[][2]string {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "[][2]string")
	if p == nil {
		return nil
	}
	return p.(*[][2]string)
}
func deptrFromHandle_Slice__2_string(h CGoHandle) [][2]string {
	p := ptrFromHandle_Slice__2_string(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Slice__2_string(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("[][2]string", p))
}

// --- wrapping slice: [][2]string ---
//export Slice__2_string_CTor
func Slice__2_string_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Slice__2_string(&[][2]string{}))
}

//export Slice__2_string_len
func Slice__2_string_len(handle CGoHandle) int {
	return len(deptrFromHandle_Slice__2_string(handle))
}

//export Slice__2_string_elem
func Slice__2_string_elem(handle CGoHandle, _idx int) CGoHandle {
	s := deptrFromHandle_Slice__2_string(handle)
	return handleFromPtr_Array_2_string(s[_idx])
}

//export Slice__2_string_subslice
func Slice__2_string_subslice(handle CGoHandle, _st, _ed int) CGoHandle {
	s := deptrFromHandle_Slice__2_string(handle)
	ss := s[_st:_ed]
	return CGoHandle(handleFromPtr_Slice__2_string(&ss))
}

//export Slice__2_string_set
func Slice__2_string_set(handle CGoHandle, _idx int, _vl CGoHandle) {
	s := deptrFromHandle_Slice__2_string(handle)
	s[_idx] = deptrFromHandle_Array_2_string(_vl)
}

//export Slice__2_string_append
func Slice__2_string_append(handle CGoHandle, _vl CGoHandle) {
	s := ptrFromHandle_Slice__2_string(handle)
	*s = append(*s, deptrFromHandle_Array_2_string(_vl))
}

// Converters for non-pointer handles for type: tokenizer.Encoder
func ptrFromHandle_tokenizer_Encoder(h CGoHandle) *tokenizer.Encoder {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "tokenizer.Encoder")
	if p == nil {
		return nil
	}
	return gopyh.Embed(p, reflect.TypeOf(tokenizer.Encoder{})).(*tokenizer.Encoder)
}
func handleFromPtr_tokenizer_Encoder(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("tokenizer.Encoder", p))
}

// Converters for non-pointer handles for type: tokenizer.Merge
func ptrFromHandle_tokenizer_Merge(h CGoHandle) *tokenizer.Merge {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "tokenizer.Merge")
	if p == nil {
		return nil
	}
	return gopyh.Embed(p, reflect.TypeOf(tokenizer.Merge{})).(*tokenizer.Merge)
}
func handleFromPtr_tokenizer_Merge(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("tokenizer.Merge", p))
}

// Converters for non-pointer handles for type: tokenizer.WordCount
func ptrFromHandle_tokenizer_WordCount(h CGoHandle) *tokenizer.WordCount {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "tokenizer.WordCount")
	if p == nil {
		return nil
	}
	return gopyh.Embed(p, reflect.TypeOf(tokenizer.WordCount{})).(*tokenizer.WordCount)
}
func handleFromPtr_tokenizer_WordCount(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("tokenizer.WordCount", p))
}

// Converters for implicit pointer handles for type: map[[2]string]int64
func ptrFromHandle_Map__2_string_int64(h CGoHandle) *map[[2]string]int64 {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "map[[2]string]int64")
	if p == nil {
		return nil
	}
	return p.(*map[[2]string]int64)
}
func deptrFromHandle_Map__2_string_int64(h CGoHandle) map[[2]string]int64 {
	p := ptrFromHandle_Map__2_string_int64(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Map__2_string_int64(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("map[[2]string]int64", p))
}

// --- wrapping map: map[[2]string]int64 ---
//export Map__2_string_int64_CTor
func Map__2_string_int64_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Map__2_string_int64(&map[[2]string]int64{}))
}

//export Map__2_string_int64_len
func Map__2_string_int64_len(handle CGoHandle) int {
	return len(deptrFromHandle_Map__2_string_int64(handle))
}

//export Map__2_string_int64_elem
func Map__2_string_int64_elem(handle CGoHandle, _ky CGoHandle) C.longlong {
	s := deptrFromHandle_Map__2_string_int64(handle)
	v, ok := s[deptrFromHandle_Array_2_string(_ky)]
	if !ok {
		C.PyErr_SetString(C.PyExc_KeyError, C.CString("key not in map"))
	}
	return C.longlong(v)
}

//export Map__2_string_int64_contains
func Map__2_string_int64_contains(handle CGoHandle, _ky CGoHandle) C.char {
	s := deptrFromHandle_Map__2_string_int64(handle)
	_, ok := s[deptrFromHandle_Array_2_string(_ky)]
	return boolGoToPy(ok)
}

//export Map__2_string_int64_set
func Map__2_string_int64_set(handle CGoHandle, _ky CGoHandle, _vl C.longlong) {
	s := deptrFromHandle_Map__2_string_int64(handle)
	s[deptrFromHandle_Array_2_string(_ky)] = int64(_vl)
}

//export Map__2_string_int64_delete
func Map__2_string_int64_delete(handle CGoHandle, _ky CGoHandle) {
	s := deptrFromHandle_Map__2_string_int64(handle)
	delete(s, deptrFromHandle_Array_2_string(_ky))
}

//export Map__2_string_int64_keys
func Map__2_string_int64_keys(handle CGoHandle) CGoHandle {
	s := deptrFromHandle_Map__2_string_int64(handle)
	kys := make([][2]string, 0, len(s))
	for k := range s {
		kys = append(kys, k)
	}
	return handleFromPtr_Slice__2_string(&kys)
}

// Converters for implicit pointer handles for type: map[int64]string
func ptrFromHandle_Map_int64_string(h CGoHandle) *map[int64]string {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "map[int64]string")
	if p == nil {
		return nil
	}
	return p.(*map[int64]string)
}
func deptrFromHandle_Map_int64_string(h CGoHandle) map[int64]string {
	p := ptrFromHandle_Map_int64_string(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Map_int64_string(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("map[int64]string", p))
}

// --- wrapping map: map[int64]string ---
//export Map_int64_string_CTor
func Map_int64_string_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Map_int64_string(&map[int64]string{}))
}

//export Map_int64_string_len
func Map_int64_string_len(handle CGoHandle) int {
	return len(deptrFromHandle_Map_int64_string(handle))
}

//export Map_int64_string_elem
func Map_int64_string_elem(handle CGoHandle, _ky C.longlong) *C.char {
	s := deptrFromHandle_Map_int64_string(handle)
	v, ok := s[int64(_ky)]
	if !ok {
		C.PyErr_SetString(C.PyExc_KeyError, C.CString("key not in map"))
	}
	return C.CString(v)
}

//export Map_int64_string_contains
func Map_int64_string_contains(handle CGoHandle, _ky C.longlong) C.char {
	s := deptrFromHandle_Map_int64_string(handle)
	_, ok := s[int64(_ky)]
	return boolGoToPy(ok)
}

//export Map_int64_string_set
func Map_int64_string_set(handle CGoHandle, _ky C.longlong, _vl *C.char) {
	s := deptrFromHandle_Map_int64_string(handle)
	s[int64(_ky)] = C.GoString(_vl)
}

//export Map_int64_string_delete
func Map_int64_string_delete(handle CGoHandle, _ky C.longlong) {
	s := deptrFromHandle_Map_int64_string(handle)
	delete(s, int64(_ky))
}

//export Map_int64_string_keys
func Map_int64_string_keys(handle CGoHandle) CGoHandle {
	s := deptrFromHandle_Map_int64_string(handle)
	kys := make([]int64, 0, len(s))
	for k := range s {
		kys = append(kys, k)
	}
	return handleFromPtr_Slice_int64(&kys)
}

// Converters for implicit pointer handles for type: map[string]int64
func ptrFromHandle_Map_string_int64(h CGoHandle) *map[string]int64 {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "map[string]int64")
	if p == nil {
		return nil
	}
	return p.(*map[string]int64)
}
func deptrFromHandle_Map_string_int64(h CGoHandle) map[string]int64 {
	p := ptrFromHandle_Map_string_int64(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Map_string_int64(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("map[string]int64", p))
}

// --- wrapping map: map[string]int64 ---
//export Map_string_int64_CTor
func Map_string_int64_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Map_string_int64(&map[string]int64{}))
}

//export Map_string_int64_len
func Map_string_int64_len(handle CGoHandle) int {
	return len(deptrFromHandle_Map_string_int64(handle))
}

//export Map_string_int64_elem
func Map_string_int64_elem(handle CGoHandle, _ky *C.char) C.longlong {
	s := deptrFromHandle_Map_string_int64(handle)
	v, ok := s[C.GoString(_ky)]
	if !ok {
		C.PyErr_SetString(C.PyExc_KeyError, C.CString("key not in map"))
	}
	return C.longlong(v)
}

//export Map_string_int64_contains
func Map_string_int64_contains(handle CGoHandle, _ky *C.char) C.char {
	s := deptrFromHandle_Map_string_int64(handle)
	_, ok := s[C.GoString(_ky)]
	return boolGoToPy(ok)
}

//export Map_string_int64_set
func Map_string_int64_set(handle CGoHandle, _ky *C.char, _vl C.longlong) {
	s := deptrFromHandle_Map_string_int64(handle)
	s[C.GoString(_ky)] = int64(_vl)
}

//export Map_string_int64_delete
func Map_string_int64_delete(handle CGoHandle, _ky *C.char) {
	s := deptrFromHandle_Map_string_int64(handle)
	delete(s, C.GoString(_ky))
}

//export Map_string_int64_keys
func Map_string_int64_keys(handle CGoHandle) CGoHandle {
	s := deptrFromHandle_Map_string_int64(handle)
	kys := make([]string, 0, len(s))
	for k := range s {
		kys = append(kys, k)
	}
	return handleFromPtr_Slice_string(&kys)
}

// Converters for implicit pointer handles for type: map[string]string
func ptrFromHandle_Map_string_string(h CGoHandle) *map[string]string {
	p := gopyh.VarFromHandle((gopyh.CGoHandle)(h), "map[string]string")
	if p == nil {
		return nil
	}
	return p.(*map[string]string)
}
func deptrFromHandle_Map_string_string(h CGoHandle) map[string]string {
	p := ptrFromHandle_Map_string_string(h)
	if p == nil {
		return nil
	}
	return *p
}
func handleFromPtr_Map_string_string(p interface{}) CGoHandle {
	return CGoHandle(gopyh.Register("map[string]string", p))
}

// --- wrapping map: map[string]string ---
//export Map_string_string_CTor
func Map_string_string_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_Map_string_string(&map[string]string{}))
}

//export Map_string_string_len
func Map_string_string_len(handle CGoHandle) int {
	return len(deptrFromHandle_Map_string_string(handle))
}

//export Map_string_string_elem
func Map_string_string_elem(handle CGoHandle, _ky *C.char) *C.char {
	s := deptrFromHandle_Map_string_string(handle)
	v, ok := s[C.GoString(_ky)]
	if !ok {
		C.PyErr_SetString(C.PyExc_KeyError, C.CString("key not in map"))
	}
	return C.CString(v)
}

//export Map_string_string_contains
func Map_string_string_contains(handle CGoHandle, _ky *C.char) C.char {
	s := deptrFromHandle_Map_string_string(handle)
	_, ok := s[C.GoString(_ky)]
	return boolGoToPy(ok)
}

//export Map_string_string_set
func Map_string_string_set(handle CGoHandle, _ky *C.char, _vl *C.char) {
	s := deptrFromHandle_Map_string_string(handle)
	s[C.GoString(_ky)] = C.GoString(_vl)
}

//export Map_string_string_delete
func Map_string_string_delete(handle CGoHandle, _ky *C.char) {
	s := deptrFromHandle_Map_string_string(handle)
	delete(s, C.GoString(_ky))
}

//export Map_string_string_keys
func Map_string_string_keys(handle CGoHandle) CGoHandle {
	s := deptrFromHandle_Map_string_string(handle)
	kys := make([]string, 0, len(s))
	for k := range s {
		kys = append(kys, k)
	}
	return handleFromPtr_Slice_string(&kys)
}

// ---- Global Variables: can only use functions to access ---

// ---- Interfaces ---

// ---- Structs ---

// --- wrapping struct: tokenizer.Merge ---
//export tokenizer_Merge_CTor
func tokenizer_Merge_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_tokenizer_Merge(&tokenizer.Merge{}))
}

//export tokenizer_Merge_Merge_Get
func tokenizer_Merge_Merge_Get(handle CGoHandle) CGoHandle {
	op := ptrFromHandle_tokenizer_Merge(handle)
	return handleFromPtr_Array_2_string(&op.Merge)
}

//export tokenizer_Merge_Count_Get
func tokenizer_Merge_Count_Get(handle CGoHandle) C.longlong {
	op := ptrFromHandle_tokenizer_Merge(handle)
	return C.longlong(op.Count)
}

//export tokenizer_Merge_Count_Set
func tokenizer_Merge_Count_Set(handle CGoHandle, val C.longlong) {
	op := ptrFromHandle_tokenizer_Merge(handle)
	op.Count = int64(val)
}

// --- wrapping struct: tokenizer.WordCount ---
//export tokenizer_WordCount_CTor
func tokenizer_WordCount_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_tokenizer_WordCount(&tokenizer.WordCount{}))
}

//export tokenizer_WordCount_Pieces_Get
func tokenizer_WordCount_Pieces_Get(handle CGoHandle) CGoHandle {
	op := ptrFromHandle_tokenizer_WordCount(handle)
	return handleFromPtr_Slice_string(&op.Pieces)
}

//export tokenizer_WordCount_Pieces_Set
func tokenizer_WordCount_Pieces_Set(handle CGoHandle, val CGoHandle) {
	op := ptrFromHandle_tokenizer_WordCount(handle)
	op.Pieces = deptrFromHandle_Slice_string(val)
}

//export tokenizer_WordCount_Count_Get
func tokenizer_WordCount_Count_Get(handle CGoHandle) C.longlong {
	op := ptrFromHandle_tokenizer_WordCount(handle)
	return C.longlong(op.Count)
}

//export tokenizer_WordCount_Count_Set
func tokenizer_WordCount_Count_Set(handle CGoHandle, val C.longlong) {
	op := ptrFromHandle_tokenizer_WordCount(handle)
	op.Count = int64(val)
}

// --- wrapping struct: tokenizer.Encoder ---
//export tokenizer_Encoder_CTor
func tokenizer_Encoder_CTor() CGoHandle {
	return CGoHandle(handleFromPtr_tokenizer_Encoder(&tokenizer.Encoder{}))
}

//export tokenizer_Encoder_Encoder_Get
func tokenizer_Encoder_Encoder_Get(handle CGoHandle) CGoHandle {
	op := ptrFromHandle_tokenizer_Encoder(handle)
	return handleFromPtr_Map_string_int64(&op.Encoder)
}

//export tokenizer_Encoder_Encoder_Set
func tokenizer_Encoder_Encoder_Set(handle CGoHandle, val CGoHandle) {
	op := ptrFromHandle_tokenizer_Encoder(handle)
	op.Encoder = deptrFromHandle_Map_string_int64(val)
}

//export tokenizer_Encoder_Decoder_Get
func tokenizer_Encoder_Decoder_Get(handle CGoHandle) CGoHandle {
	op := ptrFromHandle_tokenizer_Encoder(handle)
	return handleFromPtr_Map_int64_string(&op.Decoder)
}

//export tokenizer_Encoder_Decoder_Set
func tokenizer_Encoder_Decoder_Set(handle CGoHandle, val CGoHandle) {
	op := ptrFromHandle_tokenizer_Encoder(handle)
	op.Decoder = deptrFromHandle_Map_int64_string(val)
}

//export tokenizer_Encoder_BPERanks_Get
func tokenizer_Encoder_BPERanks_Get(handle CGoHandle) CGoHandle {
	op := ptrFromHandle_tokenizer_Encoder(handle)
	return handleFromPtr_Map__2_string_int64(&op.BPERanks)
}

//export tokenizer_Encoder_BPERanks_Set
func tokenizer_Encoder_BPERanks_Set(handle CGoHandle, val CGoHandle) {
	op := ptrFromHandle_tokenizer_Encoder(handle)
	op.BPERanks = deptrFromHandle_Map__2_string_int64(val)
}

//export tokenizer_Encoder_Cache_Get
func tokenizer_Encoder_Cache_Get(handle CGoHandle) CGoHandle {
	op := ptrFromHandle_tokenizer_Encoder(handle)
	return handleFromPtr_Map_string_string(&op.Cache)
}

//export tokenizer_Encoder_Cache_Set
func tokenizer_Encoder_Cache_Set(handle CGoHandle, val CGoHandle) {
	op := ptrFromHandle_tokenizer_Encoder(handle)
	op.Cache = deptrFromHandle_Map_string_string(val)
}

//export tokenizer_Encoder_VocabSize_Get
func tokenizer_Encoder_VocabSize_Get(handle CGoHandle) C.longlong {
	op := ptrFromHandle_tokenizer_Encoder(handle)
	return C.longlong(op.VocabSize)
}

//export tokenizer_Encoder_VocabSize_Set
func tokenizer_Encoder_VocabSize_Set(handle CGoHandle, val C.longlong) {
	op := ptrFromHandle_tokenizer_Encoder(handle)
	op.VocabSize = int64(val)
}

//export tokenizer_Encoder_EncodeWords
func tokenizer_Encoder_EncodeWords(_handle CGoHandle, words CGoHandle) CGoHandle {
	vifc, __err := gopyh.VarFromHandleTry((gopyh.CGoHandle)(_handle), "*tokenizer.Encoder")
	if __err != nil {
		return handleFromPtr_Slice_int64(nil)
	}
	cret := gopyh.Embed(vifc, reflect.TypeOf(tokenizer.Encoder{})).(*tokenizer.Encoder).EncodeWords(deptrFromHandle_Slice_string(words))

	return handleFromPtr_Slice_int64(&cret)
}

//export tokenizer_Encoder_Encode
func tokenizer_Encoder_Encode(_handle CGoHandle, text *C.char) CGoHandle {
	vifc, __err := gopyh.VarFromHandleTry((gopyh.CGoHandle)(_handle), "*tokenizer.Encoder")
	if __err != nil {
		return handleFromPtr_Slice_int64(nil)
	}
	cret := gopyh.Embed(vifc, reflect.TypeOf(tokenizer.Encoder{})).(*tokenizer.Encoder).Encode(C.GoString(text))

	return handleFromPtr_Slice_int64(&cret)
}

//export tokenizer_Encoder_Decode
func tokenizer_Encoder_Decode(_handle CGoHandle, tokens CGoHandle) *C.char {
	vifc, __err := gopyh.VarFromHandleTry((gopyh.CGoHandle)(_handle), "*tokenizer.Encoder")
	if __err != nil {
		return C.CString("")
	}
	return C.CString(gopyh.Embed(vifc, reflect.TypeOf(tokenizer.Encoder{})).(*tokenizer.Encoder).Decode(deptrFromHandle_Slice_int64(tokens)))

}

// ---- Slices ---

// ---- Maps ---

// ---- Constructors ---

//export tokenizer_New
func tokenizer_New(encoder CGoHandle, bpeMerges CGoHandle) CGoHandle {
	cret, __err := tokenizer.New(deptrFromHandle_Map_string_int64(encoder), deptrFromHandle_Slice__2_string(bpeMerges))

	if __err != nil {
		estr := C.CString(__err.Error())
		C.PyErr_SetString(C.PyExc_RuntimeError, estr)
		C.free(unsafe.Pointer(estr))
		return handleFromPtr_Ptr_tokenizer_Encoder(nil)
	}
	return handleFromPtr_Ptr_tokenizer_Encoder(cret)
}

//export tokenizer_NewFromPrebuilt
func tokenizer_NewFromPrebuilt(name *C.char) CGoHandle {
	cret, __err := tokenizer.NewFromPrebuilt(C.GoString(name))

	if __err != nil {
		estr := C.CString(__err.Error())
		C.PyErr_SetString(C.PyExc_RuntimeError, estr)
		C.free(unsafe.Pointer(estr))
		return handleFromPtr_Ptr_tokenizer_Encoder(nil)
	}
	return handleFromPtr_Ptr_tokenizer_Encoder(cret)
}

//export tokenizer_NewFromReaders
func tokenizer_NewFromReaders(encoderReader CGoHandle, vocabReader CGoHandle) CGoHandle {
	cret, __err := tokenizer.NewFromReaders(ptrFromHandle_io_Reader(encoderReader), ptrFromHandle_io_Reader(vocabReader))

	if __err != nil {
		estr := C.CString(__err.Error())
		C.PyErr_SetString(C.PyExc_RuntimeError, estr)
		C.free(unsafe.Pointer(estr))
		return handleFromPtr_Ptr_tokenizer_Encoder(nil)
	}
	return handleFromPtr_Ptr_tokenizer_Encoder(cret)
}

// ---- Functions ---

//export tokenizer_CountString
func tokenizer_CountString(s *C.char) CGoHandle {
	cret := tokenizer.CountString(C.GoString(s))

	return handleFromPtr_Map_string_int64(&cret)
}

//export tokenizer_MergeCounts
func tokenizer_MergeCounts(a CGoHandle, b CGoHandle, goRun C.char) {
	if boolPyToGo(goRun) {
		go tokenizer.MergeCounts(deptrFromHandle_Map_string_int64(a), deptrFromHandle_Map_string_int64(b))
	} else {
		tokenizer.MergeCounts(deptrFromHandle_Map_string_int64(a), deptrFromHandle_Map_string_int64(b))
	}
}

//export tokenizer_WordSplit
func tokenizer_WordSplit(s *C.char) CGoHandle {
	cret := tokenizer.WordSplit(C.GoString(s))

	return handleFromPtr_Slice_string(&cret)
}

//export tokenizer_CountReader
func tokenizer_CountReader(reader CGoHandle) CGoHandle {
	cret, __err := tokenizer.CountReader(ptrFromHandle_io_Reader(reader))

	if __err != nil {
		estr := C.CString(__err.Error())
		C.PyErr_SetString(C.PyExc_RuntimeError, estr)
		C.free(unsafe.Pointer(estr))
		return handleFromPtr_Map_string_int64(nil)
	}
	return handleFromPtr_Map_string_int64(&cret)
}
